#ifndef CHUNKRENDERER_H
#define CHUNKRENDERER_H

#include "client/engine/Mesh.h"
#include "client/engine/Shader.h"
#include "client/engine/Texture.h"
#include "client/engine/DirectRenderer.h"
#include "common/world/IChunkListener.h"
#include "client/math/Camera3D.h"

class ChunkRenderer : public IChunkListener
{
public:
    ChunkRenderer();
    virtual ~ChunkRenderer();
    
    void renderTick(Shader& shader, Camera3D camera, DirectRenderer& dr, float lag);
    void updateChunk(Chunk& c, Chunk* north, Chunk* east, Chunk* south, Chunk* west) override;
private:
    void buildChunk(int partionY, Chunk& c, Chunk* north, Chunk* east, Chunk* south, Chunk* west);
    
    const int chunkX = 32;
    const int chunkZ = 32;
    NormalTextureMesh* mesh;
    
    Texture blockTexture;
};

#endif

