#ifndef CLIENTCHUNKPROVIDER_H
#define CLIENTCHUNKPROVIDER_H

#include "common/world/IChunkProvider.h"

class ClientChunkProvider : public IChunkProvider
{
public:
    ClientChunkProvider();
    virtual ~ClientChunkProvider();
    
    Chunk* getChunk(int x, int z) override;
    bool isChunkLoaded(int x, int z) const override;
    void forEachLoadedChunk(void* data, void (*fun) (Chunk&, void*)) const override;
    
private:
    const int chunkX = 32;
    const int chunkZ = 32;
    Chunk** chunks;
};

#endif

