#ifndef WORLD_H
#define WORLD_H

#include <iostream>
#include <vector>

#include "common/world/Chunk.h"
#include "common/world/IChunkProvider.h"
#include "common/world/IChunkListener.h"

using namespace std;

class World
{
public:
    World(IChunkProvider* chunks);
    virtual ~World();
    
    void registerChunkListener(IChunkListener* listener);
    void removeChunkListener(IChunkListener* listener);
    
    void updateDirtyChunks();
private:
    void updateChunk(Chunk& c);
    
    vector<IChunkListener*> chunkListener;
    IChunkProvider* chunks;
};

#endif

