#ifndef GAMESERVER_H
#define GAMESERVER_H

#include "server/network/IServerListener.h"
#include "server/commands/ICommandSource.h"
#include "server/commands/CommandManager.h"
#include "server/IGameServer.h"

class GameServer : public IServerListener, public ICommandSource, public IGameServer
{
public:
    void start(uint16_t port, uint16_t maxClients);
    
    void onFullServerClientConnect(int socket) const override;
    void onClientConnect(int socket) const override;
    void onClientPackage(int socket, Stream& in) const override;
    void onClientDisconnect(int socket) const override;
    
    void stop() override;
    bool isServer() const override;
    
private:
    bool isRunning = false;
    CommandManager commandManager;
};

#endif

